import * as i0 from '@angular/core';
import { TemplateRef, Directive, Inject, Input, ContentChild, NgModule, QueryList, Component, ChangeDetectionStrategy, ContentChildren } from '@angular/core';
import { __decorate, __metadata } from 'tslib';
import { Required } from '@rxap/utilities';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@rxap/pipes';
import { GetFromObjectPipeModule } from '@rxap/pipes';

class DataGridCellDefDirective {
    constructor(template) {
        this.template = template;
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
}
DataGridCellDefDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
DataGridCellDefDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: DataGridCellDefDirective, selector: "[rxapDataGridCellDef]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridCellDef]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridHeaderCellDefDirective {
    constructor(template) {
        this.template = template;
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
}
DataGridHeaderCellDefDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridHeaderCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
DataGridHeaderCellDefDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: DataGridHeaderCellDefDirective, selector: "[rxapDataGridHeaderCellDef]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridHeaderCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridHeaderCellDef]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridEditCellDefDirective {
    constructor(template) {
        this.template = template;
    }
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
}
DataGridEditCellDefDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridEditCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
DataGridEditCellDefDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: DataGridEditCellDefDirective, selector: "[rxapDataGridEditCellDef]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridEditCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridEditCellDef]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridRowDefDirective {
    constructor() {
        this.data = null;
    }
}
DataGridRowDefDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridRowDefDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
DataGridRowDefDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.1", type: DataGridRowDefDirective, selector: "[rxapDataGridRowDef]", inputs: { data: "data", name: ["rxapDataGridRowDef", "name"] }, queries: [{ propertyName: "cell", first: true, predicate: DataGridCellDefDirective, descendants: true }, { propertyName: "headerCell", first: true, predicate: DataGridHeaderCellDefDirective, descendants: true }, { propertyName: "editCell", first: true, predicate: DataGridEditCellDefDirective, descendants: true }], ngImport: i0 });
__decorate([
    Required,
    __metadata("design:type", String)
], DataGridRowDefDirective.prototype, "name", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridRowDefDirective, decorators: [{
            type: Directive,
            args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: '[rxapDataGridRowDef]'
                }]
        }], propDecorators: { data: [{
                type: Input
            }], name: [{
                type: Input,
                args: ['rxapDataGridRowDef']
            }], cell: [{
                type: ContentChild,
                args: [DataGridCellDefDirective]
            }], headerCell: [{
                type: ContentChild,
                args: [DataGridHeaderCellDefDirective]
            }], editCell: [{
                type: ContentChild,
                args: [DataGridEditCellDefDirective]
            }] } });

class DataGridModule {
}
DataGridModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DataGridModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridModule, declarations: [DataGridRowDefDirective,
        DataGridHeaderCellDefDirective,
        DataGridCellDefDirective,
        DataGridEditCellDefDirective], exports: [DataGridRowDefDirective,
        DataGridHeaderCellDefDirective,
        DataGridCellDefDirective,
        DataGridEditCellDefDirective] });
DataGridModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DataGridRowDefDirective,
                        DataGridHeaderCellDefDirective,
                        DataGridCellDefDirective,
                        DataGridEditCellDefDirective
                    ],
                    exports: [
                        DataGridRowDefDirective,
                        DataGridHeaderCellDefDirective,
                        DataGridCellDefDirective,
                        DataGridEditCellDefDirective
                    ]
                }]
        }] });

class DataGridReadonlyComponent {
}
DataGridReadonlyComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridReadonlyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DataGridReadonlyComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.1", type: DataGridReadonlyComponent, selector: "rxap-data-grid-readonly", inputs: { data: "data" }, host: { classAttribute: "rxap-data-grid-readonly" }, queries: [{ propertyName: "rows", predicate: DataGridRowDefDirective }], ngImport: i0, template: "<table>\n  <thead>\n  <tr>\n    <th>Label</th>\n    <th>Wert</th>\n  </tr>\n  </thead>\n  <tr *ngFor=\"let row of rows\">\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.headerCell ? row.headerCell.template : defaultHeaderCell;\n          context: { $implicit: row.name }\n        \"\n    ></ng-container>\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.cell ? row.cell.template : defaultCell;\n          context: { $implicit: data | getFromObject: row.name, data: data }\n        \"\n    ></ng-container>\n  </tr>\n</table>\n\n<ng-template #defaultCell let-value>\n  <td>{{ value }}</td>\n</ng-template>\n<ng-template #defaultHeaderCell let-name>\n  <th>{{ name }}</th>\n</ng-template>\n", styles: [""], directives: [{ type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], pipes: { "getFromObject": i2.GetFromObjectPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush });
__decorate([
    Required,
    __metadata("design:type", Object)
], DataGridReadonlyComponent.prototype, "data", void 0);
__decorate([
    Required,
    __metadata("design:type", QueryList)
], DataGridReadonlyComponent.prototype, "rows", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridReadonlyComponent, decorators: [{
            type: Component,
            args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'rxap-data-grid-readonly',
                    templateUrl: './data-grid-readonly.component.html',
                    styleUrls: ['./data-grid-readonly.component.scss'],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: { class: 'rxap-data-grid-readonly' }
                }]
        }], propDecorators: { data: [{
                type: Input
            }], rows: [{
                type: ContentChildren,
                args: [DataGridRowDefDirective]
            }] } });

class DataGridReadonlyComponentModule {
}
DataGridReadonlyComponentModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridReadonlyComponentModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DataGridReadonlyComponentModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridReadonlyComponentModule, declarations: [DataGridReadonlyComponent], imports: [GetFromObjectPipeModule,
        CommonModule], exports: [DataGridReadonlyComponent,
        DataGridModule] });
DataGridReadonlyComponentModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridReadonlyComponentModule, imports: [[
            GetFromObjectPipeModule,
            CommonModule
        ], DataGridModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.1", ngImport: i0, type: DataGridReadonlyComponentModule, decorators: [{
            type: NgModule,
            args: [{
                    exports: [
                        DataGridReadonlyComponent,
                        DataGridModule
                    ],
                    imports: [
                        GetFromObjectPipeModule,
                        CommonModule
                    ],
                    declarations: [
                        DataGridReadonlyComponent
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { DataGridCellDefDirective, DataGridEditCellDefDirective, DataGridHeaderCellDefDirective, DataGridModule, DataGridReadonlyComponent, DataGridReadonlyComponentModule, DataGridRowDefDirective };
//# sourceMappingURL=rxap-data-grid.js.map
